/**
 * @fileoverview AUTOMATICALLY GENERATED service for API.Client.DNSApi.
 * Do not edit this file by hand or your changes will be lost next time it is
 * generated.
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login&#x3D;[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login&#x3D;[логин_кабинета]&amp;salt&#x3D;[соль]&amp;response&#x3D;[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\&quot;\\n\&quot;)* (сумма md5 строки \&quot;пароль+соль+символ-перевода-строки\&quot;)  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \&quot;смена главного пароля аккаунта\&quot;.  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_&#x3D;[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \&quot;string\&quot; ]: либо просто \&quot;OK\&quot;, либо \&quot;[число]\&quot; (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \&quot;поле\&quot;:\&quot;значение\&quot;).   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \&quot;ERROR: vds.missing\&quot;.  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 * Version: 2.0.0
 * Generated at: 2016-11-03T11:50:45.847+04:00
 * Generated by: class io.swagger.codegen.languages.JavascriptClosureAngularClientCodegen
 */
goog.provide('API.Client.DNSApi');

goog.require('API.Client.inline_response_200_3');
goog.require('API.Client.inline_response_200_4');

/**
 * @constructor
 * @param {!angular.$http} $http
 * @param {!Object} $httpParamSerializer
 * @param {!angular.$injector} $injector
 * @struct
 */
API.Client.DNSApi = function($http, $httpParamSerializer, $injector) {
  /** @private {!string} */
  this.basePath_ = $injector.has('DNSApiBasePath') ?
                   /** @type {!string} */ ($injector.get('DNSApiBasePath')) :
                   'https://www.1gb.ru/api';

  /** @private {!Object<string, string>} */
  this.defaultHeaders_ = $injector.has('DNSApiDefaultHeaders') ?
                   /** @type {!Object<string, string>} */ (
                       $injector.get('DNSApiDefaultHeaders')) :
                   {};

  /** @private {!angular.$http} */
  this.http_ = $http;

  /** @package {!Object} */
  this.httpParamSerializer = $injector.get('$httpParamSerializer');
}
API.Client.DNSApi.$inject = ['$http', '$httpParamSerializer', '$injector'];

/**
 * Создание записи домена
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!string} addDnsZone зона, которую необходимо создать
 * @param {!string=} opt_addDnsRecord 
 * @param {!string=} opt_iisSiteForDns ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку
 * @param {!boolean=} opt_bindOnly 
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!string>}
 */
API.Client.DNSApi.prototype.dnsAddGet = function(token_, addDnsZone, opt_addDnsRecord, opt_iisSiteForDns, opt_bindOnly, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/dns/add';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling dnsAddGet');
  }
  // verify required parameter 'addDnsZone' is set
  if (!addDnsZone) {
    throw new Error('Missing required parameter addDnsZone when calling dnsAddGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (addDnsZone !== undefined) {
    queryParameters['add_dns_zone'] = addDnsZone;
  }

  if (opt_addDnsRecord !== undefined) {
    queryParameters['add_dns_record'] = opt_addDnsRecord;
  }

  if (opt_iisSiteForDns !== undefined) {
    queryParameters['iis_site_for_dns'] = opt_iisSiteForDns;
  }

  if (opt_bindOnly !== undefined) {
    queryParameters['bind_only'] = opt_bindOnly;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Привязка одного домена к другому
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!number} key_ ID домена из списка /dns/list
 * @param {!string=} opt_bindTo домен, к которому необходимо сделать привязку
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!string>}
 */
API.Client.DNSApi.prototype.dnsBindGet = function(token_, key_, opt_bindTo, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/dns/bind';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling dnsBindGet');
  }
  // verify required parameter 'key_' is set
  if (!key_) {
    throw new Error('Missing required parameter key_ when calling dnsBindGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (key_ !== undefined) {
    queryParameters['_key_'] = key_;
  }

  if (opt_bindTo !== undefined) {
    queryParameters['bind_to'] = opt_bindTo;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Получить список доменных имён
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.inline_response_200_3>>}
 */
API.Client.DNSApi.prototype.dnsListGet = function(token_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/dns/list';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling dnsListGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Информация по продлению доменов
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.inline_response_200_4>>}
 */
API.Client.DNSApi.prototype.dnsProlongListGet = function(token_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/dns/prolong/list';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling dnsProlongListGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Редактирование \&quot;сырой\&quot; зоны
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!number} key_ ID домена из /dns/list
 * @param {!number} sDel Значение &#39;1&#39; сообщает, что запись необходимо удалить
 * @param {!number} sAdd Значение &#39;1&#39; сообщает, что запись необходимо создать
 * @param {!string} dnsType Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV
 * @param {!string} dnsName Имя записи, либо &#39;@&#39; для корневой
 * @param {!string} dnsValue Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!string>}
 */
API.Client.DNSApi.prototype.dnsRawGet = function(token_, key_, sDel, sAdd, dnsType, dnsName, dnsValue, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/dns/raw';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling dnsRawGet');
  }
  // verify required parameter 'key_' is set
  if (!key_) {
    throw new Error('Missing required parameter key_ when calling dnsRawGet');
  }
  // verify required parameter 'sDel' is set
  if (!sDel) {
    throw new Error('Missing required parameter sDel when calling dnsRawGet');
  }
  // verify required parameter 'sAdd' is set
  if (!sAdd) {
    throw new Error('Missing required parameter sAdd when calling dnsRawGet');
  }
  // verify required parameter 'dnsType' is set
  if (!dnsType) {
    throw new Error('Missing required parameter dnsType when calling dnsRawGet');
  }
  // verify required parameter 'dnsName' is set
  if (!dnsName) {
    throw new Error('Missing required parameter dnsName when calling dnsRawGet');
  }
  // verify required parameter 'dnsValue' is set
  if (!dnsValue) {
    throw new Error('Missing required parameter dnsValue when calling dnsRawGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (key_ !== undefined) {
    queryParameters['_key_'] = key_;
  }

  if (sDel !== undefined) {
    queryParameters['s_del'] = sDel;
  }

  if (sAdd !== undefined) {
    queryParameters['s_add'] = sAdd;
  }

  if (dnsType !== undefined) {
    queryParameters['dns_type'] = dnsType;
  }

  if (dnsName !== undefined) {
    queryParameters['dns_name'] = dnsName;
  }

  if (dnsValue !== undefined) {
    queryParameters['dns_value'] = dnsValue;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Редактировать DNS-зону
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!number} key_ ID домена из /dns/list
 * @param {!number} managedMx Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить
 * @param {!number} updManagedMx Значение &#39;1&#39; подтверждает операцию
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!string>}
 */
API.Client.DNSApi.prototype.dnsRawManagedmxGet = function(token_, key_, managedMx, updManagedMx, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/dns/raw/managedmx';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling dnsRawManagedmxGet');
  }
  // verify required parameter 'key_' is set
  if (!key_) {
    throw new Error('Missing required parameter key_ when calling dnsRawManagedmxGet');
  }
  // verify required parameter 'managedMx' is set
  if (!managedMx) {
    throw new Error('Missing required parameter managedMx when calling dnsRawManagedmxGet');
  }
  // verify required parameter 'updManagedMx' is set
  if (!updManagedMx) {
    throw new Error('Missing required parameter updManagedMx when calling dnsRawManagedmxGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (key_ !== undefined) {
    queryParameters['_key_'] = key_;
  }

  if (managedMx !== undefined) {
    queryParameters['managed_mx'] = managedMx;
  }

  if (updManagedMx !== undefined) {
    queryParameters['upd_managed_mx'] = updManagedMx;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}
