/**
 * @fileoverview AUTOMATICALLY GENERATED service for API.Client.DefaultApi.
 * Do not edit this file by hand or your changes will be lost next time it is
 * generated.
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login&#x3D;[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login&#x3D;[логин_кабинета]&amp;salt&#x3D;[соль]&amp;response&#x3D;[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\&quot;\\n\&quot;)* (сумма md5 строки \&quot;пароль+соль+символ-перевода-строки\&quot;)  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \&quot;смена главного пароля аккаунта\&quot;.  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_&#x3D;[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \&quot;string\&quot; ]: либо просто \&quot;OK\&quot;, либо \&quot;[число]\&quot; (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \&quot;поле\&quot;:\&quot;значение\&quot;).   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \&quot;ERROR: vds.missing\&quot;.  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 * Version: 2.0.0
 * Generated at: 2016-11-03T11:50:45.847+04:00
 * Generated by: class io.swagger.codegen.languages.JavascriptClosureAngularClientCodegen
 */
goog.provide('API.Client.DefaultApi');

goog.require('API.Client. ');
goog.require('API.Client.inline_response_200');
goog.require('API.Client.inline_response_200_1');
goog.require('API.Client.inline_response_200_10');
goog.require('API.Client.inline_response_200_14');
goog.require('API.Client.inline_response_200_4');
goog.require('API.Client.inline_response_200_5');
goog.require('API.Client.inline_response_200_6');

/**
 * @constructor
 * @param {!angular.$http} $http
 * @param {!Object} $httpParamSerializer
 * @param {!angular.$injector} $injector
 * @struct
 */
API.Client.DefaultApi = function($http, $httpParamSerializer, $injector) {
  /** @private {!string} */
  this.basePath_ = $injector.has('DefaultApiBasePath') ?
                   /** @type {!string} */ ($injector.get('DefaultApiBasePath')) :
                   'https://www.1gb.ru/api';

  /** @private {!Object<string, string>} */
  this.defaultHeaders_ = $injector.has('DefaultApiDefaultHeaders') ?
                   /** @type {!Object<string, string>} */ (
                       $injector.get('DefaultApiDefaultHeaders')) :
                   {};

  /** @private {!angular.$http} */
  this.http_ = $http;

  /** @package {!Object} */
  this.httpParamSerializer = $injector.get('$httpParamSerializer');
}
API.Client.DefaultApi.$inject = ['$http', '$httpParamSerializer', '$injector'];

/**
 * Аккаунт: баланс
 * Возвращает текущий баланс аккаунта
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!number>}
 */
API.Client.DefaultApi.prototype.balanceGet = function(token_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/balance';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling balanceGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Аккаунт: баланс аккаунта лицензий
 * Возвращает текущий баланс аккаунта лицензий
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!number>}
 */
API.Client.DefaultApi.prototype.balanceLicGet = function(token_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/balance.lic';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling balanceLicGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Информация по дебету аккаунта
 * Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.inline_response_200>>}
 */
API.Client.DefaultApi.prototype.billingDebtGet = function(token_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/billing/debt';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling billingDebtGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Информация об аккаунте
 * Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.inline_response_200_1>>}
 */
API.Client.DefaultApi.prototype.billingInfoGet = function(token_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/billing/info';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling billingInfoGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Получить ограничения аккаунта
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!API.Client. >}
 */
API.Client.DefaultApi.prototype.billingLimitsGet = function(token_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/billing/limits';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling billingLimitsGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Информация по продлению доменов
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.inline_response_200_4>>}
 */
API.Client.DefaultApi.prototype.dnsProlongListGet = function(token_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/dns/prolong/list';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling dnsProlongListGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Создание почтового ящика
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!string} addEmail Адрес почтового ящика, который необходимо создать
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!string>}
 */
API.Client.DefaultApi.prototype.emailAddGet = function(token_, addEmail, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/email/add';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling emailAddGet');
  }
  // verify required parameter 'addEmail' is set
  if (!addEmail) {
    throw new Error('Missing required parameter addEmail when calling emailAddGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (addEmail !== undefined) {
    queryParameters['add_email'] = addEmail;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Удаление псевдонимов почтовых ящиков
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!string} key_ Адрес почтового ящика, подлежащего удалению
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!string>}
 */
API.Client.DefaultApi.prototype.emailAliasDeleteGet = function(token_, key_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/email/alias/delete';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling emailAliasDeleteGet');
  }
  // verify required parameter 'key_' is set
  if (!key_) {
    throw new Error('Missing required parameter key_ when calling emailAliasDeleteGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (key_ !== undefined) {
    queryParameters['_key_'] = key_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Получить список псевдонимов почтовых ящиков
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.inline_response_200_5>>}
 */
API.Client.DefaultApi.prototype.emailAliasListGet = function(token_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/email/alias/list';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling emailAliasListGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Удаление почтового ящика
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!string} key_ Адрес почтового ящика, подлежащего удалению
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!string>}
 */
API.Client.DefaultApi.prototype.emailDeleteGet = function(token_, key_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/email/delete';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling emailDeleteGet');
  }
  // verify required parameter 'key_' is set
  if (!key_) {
    throw new Error('Missing required parameter key_ when calling emailDeleteGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (key_ !== undefined) {
    queryParameters['_key_'] = key_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Получить список почтовых ящиков
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.inline_response_200_6>>}
 */
API.Client.DefaultApi.prototype.emailListGet = function(token_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/email/list';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling emailListGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Идентификатор последнего уведомления в аудите
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!number>}
 */
API.Client.DefaultApi.prototype.updatesLastGet = function(token_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/updates/last';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling updatesLastGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Список записей аудита
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!number} key_ ID первой записи для показа или 0 для показа всех записей
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.inline_response_200_10>>}
 */
API.Client.DefaultApi.prototype.updatesListGet = function(token_, key_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/updates/list';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling updatesListGet');
  }
  // verify required parameter 'key_' is set
  if (!key_) {
    throw new Error('Missing required parameter key_ when calling updatesListGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (key_ !== undefined) {
    queryParameters['_key_'] = key_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Удаление сайта
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!string} key_ ID сайта, полученный из /website/list
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!string>}
 */
API.Client.DefaultApi.prototype.websiteDeleteGet = function(token_, key_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/website/delete';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling websiteDeleteGet');
  }
  // verify required parameter 'key_' is set
  if (!key_) {
    throw new Error('Missing required parameter key_ when calling websiteDeleteGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (key_ !== undefined) {
    queryParameters['_key_'] = key_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Список сайтов аккаунта
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.inline_response_200_14>>}
 */
API.Client.DefaultApi.prototype.websiteListGet = function(token_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/website/list';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling websiteListGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}
