/**
 * @fileoverview AUTOMATICALLY GENERATED service for API.Client.MicrosoftSQLServerApi.
 * Do not edit this file by hand or your changes will be lost next time it is
 * generated.
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login&#x3D;[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login&#x3D;[логин_кабинета]&amp;salt&#x3D;[соль]&amp;response&#x3D;[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\&quot;\\n\&quot;)* (сумма md5 строки \&quot;пароль+соль+символ-перевода-строки\&quot;)  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \&quot;смена главного пароля аккаунта\&quot;.  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_&#x3D;[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \&quot;string\&quot; ]: либо просто \&quot;OK\&quot;, либо \&quot;[число]\&quot; (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \&quot;поле\&quot;:\&quot;значение\&quot;).   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \&quot;ERROR: vds.missing\&quot;.  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 * Version: 2.0.0
 * Generated at: 2016-11-03T11:50:45.847+04:00
 * Generated by: class io.swagger.codegen.languages.JavascriptClosureAngularClientCodegen
 */
goog.provide('API.Client.MicrosoftSQLServerApi');

goog.require('API.Client.inline_response_200_9');

/**
 * @constructor
 * @param {!angular.$http} $http
 * @param {!Object} $httpParamSerializer
 * @param {!angular.$injector} $injector
 * @struct
 */
API.Client.MicrosoftSQLServerApi = function($http, $httpParamSerializer, $injector) {
  /** @private {!string} */
  this.basePath_ = $injector.has('MicrosoftSQLServerApiBasePath') ?
                   /** @type {!string} */ ($injector.get('MicrosoftSQLServerApiBasePath')) :
                   'https://www.1gb.ru/api';

  /** @private {!Object<string, string>} */
  this.defaultHeaders_ = $injector.has('MicrosoftSQLServerApiDefaultHeaders') ?
                   /** @type {!Object<string, string>} */ (
                       $injector.get('MicrosoftSQLServerApiDefaultHeaders')) :
                   {};

  /** @private {!angular.$http} */
  this.http_ = $http;

  /** @package {!Object} */
  this.httpParamSerializer = $injector.get('$httpParamSerializer');
}
API.Client.MicrosoftSQLServerApi.$inject = ['$http', '$httpParamSerializer', '$injector'];

/**
 * Получить список аккаунтов в MSSQL
 * 
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.inline_response_200_9>>}
 */
API.Client.MicrosoftSQLServerApi.prototype.mssqlListGet = function(token_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/mssql/list';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling mssqlListGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}
