/**
 * @fileoverview AUTOMATICALLY GENERATED service for API.Client.VDSHyperVOpenVZApi.
 * Do not edit this file by hand or your changes will be lost next time it is
 * generated.
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login&#x3D;[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login&#x3D;[логин_кабинета]&amp;salt&#x3D;[соль]&amp;response&#x3D;[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\&quot;\\n\&quot;)* (сумма md5 строки \&quot;пароль+соль+символ-перевода-строки\&quot;)  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \&quot;смена главного пароля аккаунта\&quot;.  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_&#x3D;[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \&quot;string\&quot; ]: либо просто \&quot;OK\&quot;, либо \&quot;[число]\&quot; (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \&quot;поле\&quot;:\&quot;значение\&quot;).   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \&quot;ERROR: vds.missing\&quot;.  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 * Version: 2.0.0
 * Generated at: 2016-11-03T11:50:45.847+04:00
 * Generated by: class io.swagger.codegen.languages.JavascriptClosureAngularClientCodegen
 */
goog.provide('API.Client.VDSHyperVOpenVZApi');

goog.require('API.Client.inline_response_200_11');
goog.require('API.Client.inline_response_200_12');
goog.require('API.Client.inline_response_200_13');

/**
 * @constructor
 * @param {!angular.$http} $http
 * @param {!Object} $httpParamSerializer
 * @param {!angular.$injector} $injector
 * @struct
 */
API.Client.VDSHyperVOpenVZApi = function($http, $httpParamSerializer, $injector) {
  /** @private {!string} */
  this.basePath_ = $injector.has('VDSHyperVOpenVZApiBasePath') ?
                   /** @type {!string} */ ($injector.get('VDSHyperVOpenVZApiBasePath')) :
                   'https://www.1gb.ru/api';

  /** @private {!Object<string, string>} */
  this.defaultHeaders_ = $injector.has('VDSHyperVOpenVZApiDefaultHeaders') ?
                   /** @type {!Object<string, string>} */ (
                       $injector.get('VDSHyperVOpenVZApiDefaultHeaders')) :
                   {};

  /** @private {!angular.$http} */
  this.http_ = $http;

  /** @package {!Object} */
  this.httpParamSerializer = $injector.get('$httpParamSerializer');
}
API.Client.VDSHyperVOpenVZApi.$inject = ['$http', '$httpParamSerializer', '$injector'];

/**
 * Изменение параметров VDS
 * Изменение параметров уже существующего VDS
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!string=} opt_type Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39;
 * @param {!number=} opt_crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
 * @param {!number=} opt_crHvdsk Количество доступных гигабайт диска. По умолчанию 30
 * @param {!number=} opt_crHvcpu Количество ядер CPU. По умолчанию 2
 * @param {!string=} opt_template Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list
 * @param {!string=} opt_forceMemo 
 * @param {!string=} opt_hv1gbPanelVersion 
 * @param {!boolean=} opt_panelInstall Необходимо ли установить панель 1Gb на VDS
 * @param {!boolean=} opt_crSsd1 Создать всю систему на SSD
 * @param {!boolean=} opt_crHvAllSystem Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!string>}
 */
API.Client.VDSHyperVOpenVZApi.prototype.vdsCreateGet = function(token_, opt_type, opt_crHvmem, opt_crHvdsk, opt_crHvcpu, opt_template, opt_forceMemo, opt_hv1gbPanelVersion, opt_panelInstall, opt_crSsd1, opt_crHvAllSystem, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/vds/create';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling vdsCreateGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (opt_type !== undefined) {
    queryParameters['type'] = opt_type;
  }

  if (opt_crHvmem !== undefined) {
    queryParameters['cr_hvmem'] = opt_crHvmem;
  }

  if (opt_crHvdsk !== undefined) {
    queryParameters['cr_hvdsk'] = opt_crHvdsk;
  }

  if (opt_crHvcpu !== undefined) {
    queryParameters['cr_hvcpu'] = opt_crHvcpu;
  }

  if (opt_template !== undefined) {
    queryParameters['template'] = opt_template;
  }

  if (opt_forceMemo !== undefined) {
    queryParameters['force_memo'] = opt_forceMemo;
  }

  if (opt_hv1gbPanelVersion !== undefined) {
    queryParameters['hv_1gb_panel_version'] = opt_hv1gbPanelVersion;
  }

  if (opt_panelInstall !== undefined) {
    queryParameters['panel_install'] = opt_panelInstall;
  }

  if (opt_crSsd1 !== undefined) {
    queryParameters['cr_ssd1'] = opt_crSsd1;
  }

  if (opt_crHvAllSystem !== undefined) {
    queryParameters['cr_hv_all_system'] = opt_crHvAllSystem;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Удаление VDS
 * Предоставляет функционал для удаления VDS
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!number} key_ ID виртуального сервера, полученный из /vds/list
 * @param {!boolean=} opt_forceCritical Если true, VDS будет удален срочно
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!string>}
 */
API.Client.VDSHyperVOpenVZApi.prototype.vdsDeleteGet = function(token_, key_, opt_forceCritical, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/vds/delete';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling vdsDeleteGet');
  }
  // verify required parameter 'key_' is set
  if (!key_) {
    throw new Error('Missing required parameter key_ when calling vdsDeleteGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (key_ !== undefined) {
    queryParameters['_key_'] = key_;
  }

  if (opt_forceCritical !== undefined) {
    queryParameters['force_critical'] = opt_forceCritical;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Добавление IP на VDS
 * Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!number} key_ ID виртуального сервера, полученный из /vds/list
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!string>}
 */
API.Client.VDSHyperVOpenVZApi.prototype.vdsIpAddGet = function(token_, key_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/vds/ip/add';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling vdsIpAddGet');
  }
  // verify required parameter 'key_' is set
  if (!key_) {
    throw new Error('Missing required parameter key_ when calling vdsIpAddGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (key_ !== undefined) {
    queryParameters['_key_'] = key_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Удаление IP с VDS
 * Этот вызов позволяет отвязать IP адрес от VDS
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!number} key_ ID виртуального сервера, полученный из /vds/list
 * @param {!string} delIp IP адрес, который необходимо удалить
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!string>}
 */
API.Client.VDSHyperVOpenVZApi.prototype.vdsIpDeleteGet = function(token_, key_, delIp, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/vds/ip/delete';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling vdsIpDeleteGet');
  }
  // verify required parameter 'key_' is set
  if (!key_) {
    throw new Error('Missing required parameter key_ when calling vdsIpDeleteGet');
  }
  // verify required parameter 'delIp' is set
  if (!delIp) {
    throw new Error('Missing required parameter delIp when calling vdsIpDeleteGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (key_ !== undefined) {
    queryParameters['_key_'] = key_;
  }

  if (delIp !== undefined) {
    queryParameters['del_ip'] = delIp;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Список IP-адресов виртуальных серверов
 * Список IP-адресов виртуальных серверов
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!number=} opt_key_ ID виртуального сервера, полученный из /vds/list
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.inline_response_200_11>>}
 */
API.Client.VDSHyperVOpenVZApi.prototype.vdsIpListGet = function(token_, opt_key_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/vds/ip/list';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling vdsIpListGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (opt_key_ !== undefined) {
    queryParameters['_key_'] = opt_key_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Список виртуальных серверов
 * Позволяет получить список виртуальных серверов
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!number=} opt_key_ ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.inline_response_200_12>>}
 */
API.Client.VDSHyperVOpenVZApi.prototype.vdsListGet = function(token_, opt_key_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/vds/list';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling vdsListGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (opt_key_ !== undefined) {
    queryParameters['_key_'] = opt_key_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Перезагрузка VDS
 * Предоставляет функционал для перезагрузки VDS
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!number} key_ ID виртуального сервера, полученный из /vds/list
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!string>}
 */
API.Client.VDSHyperVOpenVZApi.prototype.vdsRebootGet = function(token_, key_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/vds/reboot';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling vdsRebootGet');
  }
  // verify required parameter 'key_' is set
  if (!key_) {
    throw new Error('Missing required parameter key_ when calling vdsRebootGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (key_ !== undefined) {
    queryParameters['_key_'] = key_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Список шаблонов виртуальных серверов
 * Позволяет получить список шаблонов виртуальных серверов
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!Array<!API.Client.inline_response_200_13>>}
 */
API.Client.VDSHyperVOpenVZApi.prototype.vdsTemplatesListGet = function(token_, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/vds/templates-list';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling vdsTemplatesListGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}

/**
 * Создание VDS
 * Создание новых VDS с произвольными характеристиками
 * @param {!string} token_ Ключ доступа, полученный при авторизации
 * @param {!number} key_ ID виртуального сервера, полученный из /vds/list
 * @param {!number=} opt_crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
 * @param {!number=} opt_crHvdsk Количество доступных гигабайт диска. По умолчанию 30
 * @param {!number=} opt_crHvcpu Количество ядер CPU. По умолчанию 2
 * @param {!angular.$http.Config=} opt_extraHttpRequestParams Extra HTTP parameters to send.
 * @return {!angular.$q.Promise<!string>}
 */
API.Client.VDSHyperVOpenVZApi.prototype.vdsUpdateGet = function(token_, key_, opt_crHvmem, opt_crHvdsk, opt_crHvcpu, opt_extraHttpRequestParams) {
  /** @const {string} */
  var path = this.basePath_ + '/vds/update';

  /** @type {!Object} */
  var queryParameters = {};

  /** @type {!Object} */
  var headerParams = angular.extend({}, this.defaultHeaders_);
  // verify required parameter 'token_' is set
  if (!token_) {
    throw new Error('Missing required parameter token_ when calling vdsUpdateGet');
  }
  // verify required parameter 'key_' is set
  if (!key_) {
    throw new Error('Missing required parameter key_ when calling vdsUpdateGet');
  }
  if (token_ !== undefined) {
    queryParameters['_token_'] = token_;
  }

  if (key_ !== undefined) {
    queryParameters['_key_'] = key_;
  }

  if (opt_crHvmem !== undefined) {
    queryParameters['cr_hvmem'] = opt_crHvmem;
  }

  if (opt_crHvdsk !== undefined) {
    queryParameters['cr_hvdsk'] = opt_crHvdsk;
  }

  if (opt_crHvcpu !== undefined) {
    queryParameters['cr_hvcpu'] = opt_crHvcpu;
  }

  /** @type {!Object} */
  var httpRequestParams = {
    method: 'GET',
    url: path,
    json: true,
            params: queryParameters,
    headers: headerParams
  };

  if (opt_extraHttpRequestParams) {
    httpRequestParams = angular.extend(httpRequestParams, opt_extraHttpRequestParams);
  }

  return (/** @type {?} */ (this.http_))(httpRequestParams);
}
